package com.totopia.server.modules.site.service;

import com.totopia.server.commons.exception.ResourceNotFoundException;
import com.totopia.server.modules.site.entity.BankInfoEntity;
import com.totopia.server.modules.site.repository.BankInfoRepository;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
@Slf4j
public class BankInfoService {

  @Autowired
  BankInfoRepository bankInfoRepository;

  public BankInfoEntity save(BankInfoEntity entity) {
    return this.bankInfoRepository.save(entity);
  }

  public BankInfoEntity modify(BankInfoEntity entity) {
    if(entity == null || entity.getId() == 0) {
      log.error("id is not null");
    }

    return this.bankInfoRepository.save(entity);
  }

  public Short removeById(Short bankInfoId) {
    return bankInfoRepository.findById(bankInfoId).map(bankInfo -> {
      bankInfoRepository.delete(bankInfo);
      return bankInfoId;
    }).orElseThrow(() -> new ResourceNotFoundException("BankInfoEntity", "bankInfoId", bankInfoId));
  }

  public Page<BankInfoEntity> getAllBankInfo(Pageable pageable) {

    return this.bankInfoRepository.findAll(pageable);
  }

  public List<BankInfoEntity> getAllBankInfoTest() {


    return this.bankInfoRepository.findAll();
  }

  public BankInfoEntity getBankInfoById(Short bankInfoId) {
    return this.bankInfoRepository.findById(bankInfoId).orElseThrow(null);
  }
}
