package com.totopia.server.modules.user.entity;

import com.totopia.server.commons.data.entity.UserDateAuditEntity;
import com.totopia.server.modules.user.type.StatusName;
import lombok.*;
import lombok.experimental.SuperBuilder;

import javax.persistence.*;

@Entity(name = "bank")
@Data
@SuperBuilder
@NoArgsConstructor
@AllArgsConstructor
@EqualsAndHashCode(callSuper = false)
@Builder
public class BankEntity extends UserDateAuditEntity {

  private static final long serialVersionUID = -8628291684559836128L;

  @Id
  @GeneratedValue(generator = "bank_generator")
  @SequenceGenerator(name = "bank_generator", sequenceName = "bank_sequence", initialValue = 1)
  private Long id;

  @Basic
  @Column(name = "userId", nullable = false)
  private Long userId;

  @Basic
  @Column(name = "bank_account_id", nullable = false)
  private Long bankAccountId;

  @Basic
  @Column(name = "name", nullable = false, length = 100)
  private String name;

  @Basic
  @Column(name = "number", nullable = false, length = 100)
  private String number;

  @Basic
  @Column(name = "holder", nullable = false, length = 100)
  private String holder;

  @Basic
  @Column(name = "password", nullable = false, length = 100)
  private String password;

  @Basic
  @Column(name = "status", nullable = false, length = 100)
  private StatusName status;



}
