package com.totopia.server.modules.user.repository;

import com.totopia.server.modules.user.entity.BankEntity;
import com.totopia.server.modules.user.entity.DepositEntity;
import com.totopia.server.modules.user.entity.UserEntity;
import com.totopia.server.modules.user.type.BankingName;
import org.junit.Before;
import org.junit.Ignore;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;

import java.util.List;

@Ignore
@RunWith(SpringRunner.class)
@SpringBootTest
public class DepositRepositoryTest {

    @Autowired
    private UserRepository userRepository;
    @Autowired
    private BankRepository bankRepository;
    @Autowired
    private DepositRepository depositRepository;

    List<UserEntity> users;
    List<BankEntity> accounts;

    @Before
    public void setUp() throws Exception {
        users = this.userRepository.findAll();
        accounts = this.bankRepository.findAll();

    }

    @Test
    public void insertTest() throws Exception {
        DepositEntity en = DepositEntity.builder()
                .price(10000)
                .bankAccount((short) 1)
                .approve(accounts.get(0).getId())
                .bank(accounts.get(2).getId())
                .status(BankingName.BANKING_WAITING)

                .build();

//        DepositEntity entity = new DepositEntity();
//
//        entity.setAmountOfMoney(2000000);
//        entity.setBankAccount(accounts.get(1).getId());
//        entity.setConfirmUser(accounts.get(0).getId());
//        entity.setDepositUser(accounts.get(1).getId());
//        entity.setStatus(ProcessingStatus.PROCESSING_WAITING);
//        entity.setCreatedBy(accounts.get(1).getId());
//        entity.setUpdatedBy(accounts.get(1).getId());

        this.depositRepository.save(en);
    }

    @Test
    public void updateTest() throws Exception {
        DepositEntity entity = this.depositRepository.findById(1L).orElse(null);
        entity.setStatus(BankingName.BANKING_COMPLETE);
        this.depositRepository.save(entity);
//        assertEquals(entity.getDepositUser().longValue(), 2L);
    }
}